/*
**	Program to draw a pixel map of from a given file`		**
**									**
**	Created by Anirudha Shimpi					**
**		for Dr. David Tarboton					**
**									**
**	Parmeters :							**
**		arg1 : filename of matrix to be mapped			**
*/

#include <stdio.h>
#include <X11/Xlib.h>
#include <math.h>

extern	Display	*theDisplay;
extern	int	theWidth;
extern	int	theHeight;

Window 	theWindow;
GC 	theGC;
short 	*ipixmap;
float 	*rpixmap;
int 	*lpixmap;
char 	datatype;
int 	WINX=400;
int	WINY=400;
int 	xtopleft=20;
int 	ytopleft=20;
int 	cmin,rmin,cmax,rmax;

main(argc,argv)

int 	argc;
char 	*argv[];

{
char 	*ipfilename;
int 	thresh;
int 	nx,ny,igy=0,first=True,xoff,yoff;
float 	dx,dy;
unsigned mapsize;
FILE 	*ipfile;
char 	reply[1],temptype;
float 	blockwidth=1,blockheight=1;

if (argc>1) {
	ipfilename=argv[1];
	initX();
	getXinfo();
	if (!getfileinfo(ipfilename,&mapsize,&datatype)) {
		fprintf (stdout,"File error (01)\nProgram terminated\n");
		return (0);
		}
	temptype=datatype;
	switch (datatype) {
		case 'i' : 
			ipixmap = (short *)malloc(mapsize*sizeof(*ipixmap));
			if (ipixmap == NULL) {
				fprintf(stdout,
					"MALLOC failed\nprogram terminated\n");
				return(0);
				}
			demread_ (ipixmap,ipfilename,&nx,&ny,&igy,&dx,&dy);
			break;
		case 'f' : 
			rpixmap = (float *)malloc(mapsize*sizeof(*rpixmap));
			if (rpixmap == NULL) {
				fprintf(stdout,
					"MALLOC failed\nprogram terminated\n");
				return(0);
				}
			demread_ (rpixmap,ipfilename,&nx,&ny,&igy,&dx,&dy);
			break;
		case 'l' : 
			lpixmap = (int *)malloc(mapsize*sizeof(*lpixmap));
			if (lpixmap == NULL) {
				fprintf(stdout,
					"MALLOC failed\nprogram terminated\n");
				return(0);
				}
			demread_ (lpixmap,ipfilename,&nx,&ny,&igy,&dx,&dy);
			break;
		default : fprintf (stdout,"File error (02)\nProgram terminated\n");
			return (0);
		}
	getWindowSize();
	reply[0] = 'y' ;
	while (reply[0] == 'y' || reply[0] == 'Y') {
		getSubarray(nx,ny,&first,blockwidth,blockheight,xoff,yoff);
		fprintf (stdout,"Enter desired threshold : ");
		fscanf (stdin,"%d",&thresh);
		XClearWindow(theDisplay,theWindow);
		datatype=temptype;
		plot(thresh,nx,ny,dx,dy,&blockwidth,&blockheight,&xoff,&yoff);
		fprintf (stdout,"Do you want another plot on the same data [y/n] :");
		fscanf (stdin,"%s",reply);
		}
	free(ipixmap);
	free(rpixmap);
	free(lpixmap);
	quitX();
	}
else
	fprintf(stdout,"usage: pixmap <input file> \n");
}

plot(thresh,nx,ny,dx,dy,blockwidth,blockheight,xoff,yoff)

int 	thresh;
int 	nx,ny;
float	dx,dy;
float 	*blockwidth,*blockheight;
int	*xoff,*yoff;

{
int 	i,j,tempi;
float 	tempr;
int 	templ;
char 	reply[1];
float 	lx,ly,viewx,viewy;
int	x,y,pointerEvent;

fprintf(stdout,"Plot with threshold = %d\n",thresh);
viewx= WINX*0.9 + 1;
viewy= WINY*0.9 + 1;
lx= (cmax-cmin+1)*dx;
ly= (rmax-rmin+1)*dy;
XMapRaised(theDisplay,theWindow);
XFlush(theDisplay);
if (lx/ly > viewx/viewy) {
	*blockwidth= viewx/(cmax-cmin+1);
	*blockheight= (*blockwidth)*dy/dx;
	*xoff= (WINX-viewx)/2;
	*yoff= (WINY-viewy)/2 + (viewy-(rmax-rmin+1)*(*blockheight))/2;
	}
else {
	*blockheight= viewy/(rmax-rmin+1);
	*blockwidth= (*blockheight)*dx/dy;
	*yoff= (WINY-viewy)/2;
	*xoff= (WINX-viewx)/2 + (viewx-(cmax-cmin+1)*(*blockwidth))/2;
	}
drawRectangle(theWindow,theGC,*xoff,*yoff,
	(int) ((cmax-cmin)*(*blockwidth)+ceil(*blockwidth)),
        (int) ((rmax-rmin)*(*blockheight)+ceil(*blockheight)));
XFlush(theDisplay);
for (j=cmin-1;j<cmax;j++)
  for (i=rmin-1;i<rmax;i++) 
    switch (datatype) {
      case 'f' : {
	tempr=(*(rpixmap+ny*j+i));
	if (((int)tempr) > thresh)				    						plotPoint(j-cmin+1,i-rmin+1,*blockwidth,*blockheight,*xoff,*yoff);
	break;
	}
      case 'i' : {
	tempi= *(ipixmap+ny*j+i);
	if (tempi > thresh)
		plotPoint(j-cmin+1,i-rmin+1,*blockwidth,*blockheight,*xoff,*yoff);
	break;
	}
      case 'l' : templ = (*(lpixmap+ny*j+i));
	if (templ > thresh)
		plotPoint(j-cmin+1,i-rmin+1,*blockwidth,*blockheight,*xoff,*yoff);
    }
drawRectangle(theWindow,theGC,*xoff,*yoff,
	(int) ((cmax-cmin)*(*blockwidth)+ceil(*blockwidth)),
        (int) ((rmax-rmin)*(*blockheight)+ceil(*blockheight)));
XFlush (theDisplay);
fprintf(stdout,"\nDo you wish to locate a point? [y/n] ");
fscanf(stdin,"%s",reply);
if (reply[0] == 'y' || reply[0] == 'Y') {
	fprintf(stdout,"Press Button 1 of pointer on location to get it's position");
	fprintf(stdout,"\nPress 'q' to stop\n") ;
	initEvents (theWindow);
	while (eventLoop(theWindow,theGC,&x,&y,&pointerEvent)) 
		if (pointerEvent) 
			printLocation(nx,ny,x-*xoff,y-*yoff,
				*blockwidth,*blockheight,cmin,rmin);
	XFlush(theDisplay);
	}
}

plotPoint (x,y,w,h,xoff,yoff)

int 	x,y;
float	w,h;
int 	xoff,yoff;

{
int 	x1,y1,width,height;

x1= (int) (x*w);
y1= (int) (y*h);
width= (int) ceil(w);
height= (int) ceil(h);
fillRectangle (theWindow,theGC,x1+xoff,y1+yoff,width,height);
}


printLocation(nx,ny,x,y,blockwidth,blockheight,colmin,rowmin)

int 	nx,ny,x,y;
float	blockwidth,blockheight;
int 	colmin,rowmin;

{ 
int 	xpos,ypos;

xpos= (int) (x/blockwidth)+colmin;
ypos= (int) (y/blockheight)+rowmin;
fprintf(stdout,"The location was row, col: %d,%d\n",ypos,xpos);
if (xpos<=cmax && ypos<=rmax && xpos>=colmin && ypos>=rowmin) 
	switch (datatype) {
		case 'i' : fprintf(stdout,"The value was : %d\n",
				*(ipixmap+ny*(xpos-1)+(ypos-1)));
			break;
		case 'f' : fprintf(stdout,"The value was : %f\n",
				*(rpixmap+ny*(xpos-1)+(ypos-1)));
			break;
		case 'l' : fprintf(stdout,"The value was : %d\n",
				*(lpixmap+ny*(xpos-1)+(ypos-1)));
	} /* switch (1) */
else
	fprintf(stdout,"Located point outside plotted area\n");
} /* printLocation */

getSubarray(nx,ny,first,blockwidth,blockheight,xoff,yoff)

int 	nx,ny,*first;
float 	blockwidth,blockheight;
int	xoff,yoff;

{
char 	reply[1];
int 	tempcmin,tnx,tny;

tnx=nx;tny=ny;
fprintf(stdout,"Number of Columns : %d\nNumber of Rows : %d\n",nx,ny);
if (*first) {
	fprintf(stdout,"\nEnter Subarray to plot COLMIN COLMAX ROWMIN ROWMAX :");
	fscanf(stdin,"%d,%d,%d,%d",&cmin,&cmax,&rmin,&rmax);
	fprintf(stdout,"\n");
	while (cmin<0 || cmax>nx || rmin<0 || rmax>ny) {
		fprintf(stdout,"Row and Column of submatrix out of range\n");
		printf("\nEnter Subarray to plot COLMIN COLMAX ROWMIN ROWMAX :");
		fscanf(stdin,"%d,%d,%d,%d",&cmin,&cmax,&rmin,&rmax);
		printf("\n");
		}
	*first=False;
	}
else {
	fprintf(stdout,
		"Enter\t`1' to Zoom in\n\t`2' to enter new submatrix (zoom out)\n");
	fprintf(stdout,"\t`3' to use same submatrix (different threshold)\n");
	fscanf(stdin,"%s",reply);
	switch (reply[0]) {
		case '1' : getFromScreen(tnx,tny,blockwidth,blockheight,xoff,yoff);
			break;

		case '2' : fprintf(stdout,
				"Enter Subarray to plot COLMIN COLMAX ROWMIN ROWMAX :");
			fscanf(stdin,"%d,%d,%d,%d",&cmin,&cmax,&rmin,&rmax);
			while (cmin<0 || cmax>tnx || rmin<0 || rmax>tny) {
				fprintf(stdout,
				"Row and Column of submatrix out of range\n");
				fprintf(stdout,
				"Enter Subarray to plot COLMIN COLMAX ROWMIN ROWMAX :");
				fscanf(stdin,"%d,%d,%d,%d",&cmin,&cmax,&rmin,&rmax);
				}
			break;
	
		case '3' : break;
		} /* switch (1) */
	} /* else */
} /* getSubarray */

getFromScreen (nx,ny,blockwidth,blockheight,xoff,yoff)

int 	nx,ny;
float 	blockwidth,blockheight;
int 	xoff,yoff;

{
int 	pointerEvent=0;
int 	oldcmin,oldrmin;
int 	oldcmax,oldrmax,done=False;

oldcmin= cmin;
oldrmin= rmin;
oldcmax= cmax;
oldrmax= rmax;
initEvents(theWindow);
fprintf(stdout,"Click button 1 of pointer on upper left corner of submatrix\n");
while (!done) {
	eventLoop(theWindow,theGC,&cmin,&rmin,&pointerEvent);
	printLocation(nx,ny,cmin-xoff,rmin-yoff,blockwidth,blockheight,oldcmin,oldrmin);
	cmin= (int) ((cmin-xoff)/blockwidth)+oldcmin;
	rmin= (int) ((rmin-yoff)/blockheight)+oldrmin;
	if (cmin>=oldcmin && rmin>=oldrmin)
		done= True;
	else
		fprintf(stdout,
			"Point outside array, choose another\n");
	}
done= False;
while (!done) {
	eventLoop(theWindow,theGC,&cmax,&rmax,&pointerEvent);	
	printLocation(nx,ny,cmax-xoff,rmax-yoff,blockwidth,blockheight,oldcmin,oldrmin);
	cmax= ((cmax-xoff)/blockwidth)+ oldcmin;
	rmax= ((rmax-yoff)/blockheight)+oldrmin;
	if (cmax>=cmin && cmax<=oldcmax && rmax>=rmin && rmax<=oldrmax)
		done=True;
	else
		fprintf(stdout,
			"Point outside array, choose another\n");
	} /* while */
fprintf(stdout,"Subarray to be plotted is %d,%d to %d,%d\n",
	cmin,rmin,cmax,rmax);
}

getWindowSize ()

{
char 	reply[1];

fprintf(stdout,"\nEnter Window Size desired\n");
fprintf(stdout,"\t`1'\tDefault window (400x400)\n");
fprintf(stdout,"\t`2'\tFull Screen\n");
fprintf(stdout,"\t`3'\tHalf Screen\n");
fprintf(stdout,"\t`4'\tYour own size\n");
fscanf(stdin,"%s",reply);
switch (reply[0]) {
	case '1' : WINX= 400;
		WINY= 400;
		theWindow= openWindow(xtopleft,ytopleft,
			WINX,WINY,0,&theGC);
		break;
	case '2' : WINX= (int) theWidth-xtopleft;
		WINY= (int) theHeight*0.9-ytopleft;
		theWindow= openWindow(xtopleft,ytopleft,
			WINX+0,WINY+0,0,&theGC);
		break;
	case '3' : WINX= (int) theWidth/2;
		WINY= (int) theHeight-ytopleft;
		theWindow=openWindow(xtopleft,ytopleft,
			WINX+0,WINY+0,0,&theGC);
		break;
	case '4' : fprintf(stdout,"Please Enter Width,Height desired\n");
		fscanf(stdin,"%d,%d",&WINX,&WINY);
		theWindow=openWindow(xtopleft,ytopleft,
			WINX+0,WINY+0,0,&theGC);
		break;
	}
}
